package addressbook;

import java.io.StringReader;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.InputSource;

/**
 * ϿץꥱǡŪ˻Ȥؿ饹
 */
public class AddressbookUtils {

		/**
		 * JAXP DocumentBuilderƤӽФ
		 * @return DocumentBuilder
		 */
		public static DocumentBuilder getDocumentBuilder() {
			DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
			dbf.setNamespaceAware(true);
			dbf.setValidating(false);
			dbf.setIgnoringElementContentWhitespace(true);
			try {
				return dbf.newDocumentBuilder();
			} catch (Exception e) {
				e.printStackTrace();
			}
			return null;
		}

		/**
		 * ʸ󤫤DOM Document
		 * @param xmlData XMLʸ
		 * @return DOM Document
		 */
		public static Document loadXMLFromString(String xmlData) {
			DocumentBuilder db = getDocumentBuilder();
			try {
				return db.parse(new InputSource(new StringReader(xmlData)));
			} catch (Exception e) {
				e.printStackTrace();
				return null;
			}
		}
		
		/**
		 * ꤷ̾ĻҥΡɤ֤
		 * @param parents Node
		 * @param tagName String
		 * @return
		 */
	    public static Node getChildNodeByTagName(Node parents, String tagName) {
			Node child = null;
			NodeList childlen = parents.getChildNodes();
			//ҥΡɤο
			int len = (childlen != null) ? childlen.getLength() : 0;
			for (int i = 0; i < len; i++) {
				Node tmpchild = childlen.item(i);
				// ̾tagNameƱǤФΥΡɤ֤
				if (tmpchild.getNodeName().equals(tagName)) {
					child = tmpchild;
					break;
				}
			}
			return child;	
		}

		/**
		 * ꤷ̾ĻҥΡɤΥƥ֤ͤ
		 * @param parents Node
		 * @param tagName String
		 * @return
		 */
	    public static String getChildNodeTextByTagName(Node parents, String tagName) {
	    	//ꤷ̾ΥΡɤ
	    	Node child = AddressbookUtils.getChildNodeByTagName(parents,tagName);
	    	String node_text = ""; 
	    	if(child != null){
	    		node_text = child.getFirstChild().getNodeValue();
	    	}
			return node_text;	
		}
	    
	    
		/**
		 * ̤Query-ResultsǤͤͤȤƼФ
		 */
		public static int getQResultInteger(Document doc){
			/*
			 * ̤Ȥ 
			 * <?xml version="1.0" encoding="UTF-8" ?>
			 * <Query-Results>
			 * 100
			 * </Query-Results>
			 * Ȥ(\n)äʸ֤äƤΤǡ
			 * Query-ResultsǤͤ\nͤ
			 */
			Element element = (Element) doc.getElementsByTagName("Query-Results")
					.item(0);
			String nodevalue = element.getFirstChild().getNodeValue().replace("\n",	"");
			// ʸ󤫤ͤ˥㥹Ȥ ʸξ0֤
			if(nodevalue.equals("")){
				return 0;
			}else{
				return Integer.parseInt(nodevalue);
			}	
		}
	    
	/**
	 * XPathʸӤԤᡢconcatؿ
	 */
	public static String getXpathConcat(String query) {

		// ʬоʸ
		String splied_query = query;
		// concatؿ
		String concat_in = "";

		//queryκǸ夬󥰥륯Ȥɤå
		if (query.lastIndexOf("'") == query.length() - 1) {
			//AǸȾѥڡɲä
			splied_query = splied_query + " ";
		}
		// 󥰥륯ȡ'ˤʬ䤹
		String[] split_sq = splied_query.split("'");
		if (query.lastIndexOf("'") == query.length() - 1) {
			// AɲäȾѥڡˤ
			split_sq[split_sq.length - 1] = "";
		}
		// concatȤ
		for (int i = 0; i < split_sq.length; i++) {
			concat_in += "'" + split_sq[i] + "'";
			if (split_sq.length != i + 1) {
				concat_in += ",\"'\",";
			}
		}
		// XPathconcatؿ֤
		return "concat( " + concat_in + " )";
	}

	/**
	 * HTMLפԤ
	 */
	public static String htmlEncode(String unescape){
		//&&amp;
		unescape = unescape.replaceAll("&","&amp;");
		//"&quot;
		unescape = unescape.replaceAll("\"","&quot;");
		//<&lt;
		unescape = unescape.replaceAll("<","&lt;");
		//>&gt;
		unescape = unescape.replaceAll(">","&gt;");
		//'&#39;
		unescape = unescape.replaceAll("'","&#39;");
		return unescape;
	}

}
