package addressbook;

import org.w3c.dom.Document;
import org.w3c.dom.NodeList;

import com.neocore.httpclient.XMLEncoder;

public class SearchAddressbookBean {

	ConnectXprioriBean xcon = null; // ConnectXprioriBean饹

	/**
	 * 󥹥ȥ饯 ConnectXprioriBean饹ƤӽФXprioriȤ³Ω
	 */
	public SearchAddressbookBean() {
		// XprioriȤ³Ω
		xcon = new ConnectXprioriBean();
	}

	/**
	 * ƥ
	 * 
	 * @return ƥ
	 */
	public int CountAllItem() {
		// ƥXPath
		String xpath = "count(/ND/address_book/item)";
		// ̤
		String tmpItem_xml = xcon.query(xpath);
		// XMLϤ
		Document doc = AddressbookUtils.loadXMLFromString(tmpItem_xml);

		return AddressbookUtils.getQResultInteger(doc);
	}

	/**
	 * ̾wordޤॢƥ
	 * @param word
	 * @return ƥ
	 */
	public int CountItemByName(String word) {
		// ƥXPath
		String xpath = "count(/ND/address_book/item[contains(name," + AddressbookUtils.getXpathConcat(XMLEncoder.xmlEncode(word)) + ")])";
		// ̤
		String tmpItem_xml = xcon.query(xpath);
		// XMLϤ
		Document doc = AddressbookUtils.loadXMLFromString(tmpItem_xml);

		return AddressbookUtils.getQResultInteger(doc);
	}

	
	/**
	 * ƥꤷ֤顢եåʬ
	 * 
	 * @param start
	 *            ֹ
	 * @param offset
	 *            եå
	 * @return ItemBean
	 */
	public ItemBean[] getItems(int start, int offset) {

		// XPathξĤ
		String xpathCondition = "position() >= " + start + " and "
				+ "position() < " + (start + offset);

		// ꤷϰϤΰiitemΡɤXPath䤤碌̤
		String itemsXML = xcon.query("/ND/address_book/item[" + xpathCondition
				+ "]");
		
		// XMLDOM Document
		Document doc = AddressbookUtils.loadXMLFromString(itemsXML);
		NodeList itemnodeList = doc.getElementsByTagName("item");
		
		// ƥĿʬItemBean
		ItemBean[] items = new ItemBean[itemnodeList.getLength()];

		for (int i = 0; i < itemnodeList.getLength(); i++) {
			items[i] = new ItemBean(itemnodeList.item(i));
		}
		return items;
	}

	/**
	 * Ϥʸ̾˴ޤॢƥꤷ֤顢եåʬ
	 * 
	 * @param name
	 *            
	 * @param start
	 *            ֹ
	 * @param offset
	 *            եå
	 * @return ItemBean
	 */
	public ItemBean[] getItemsByName(String word,int start, int offset) {

		// XPathξĤ
		// ̾wordޤitem뤿ξ
		String xpathCondition1 = "contains(name," + AddressbookUtils.getXpathConcat(XMLEncoder.xmlEncode(word)) + ")";
		// ꤷϰϤitem뤿ξ
		String xpathCondition2 = "position() >= " + start + " and "
		+ "position() < " + (start + offset);
		
		// XPath䤤碌̤
		String itemsXML = xcon.query("/ND/address_book/item[" + xpathCondition1
				+ " ][" + xpathCondition2 + "]");		
		// XMLDOM Document
		Document doc = AddressbookUtils.loadXMLFromString(itemsXML);
		NodeList itemnodeList = doc.getElementsByTagName("item");

		// եåʬItemBean
		ItemBean[] items = new ItemBean[itemnodeList.getLength()];
		for (int i = 0; i < itemnodeList.getLength(); i++) {
			items[i] = new ItemBean(itemnodeList.item(i));
		}
		return items;
	}

	/**
	 * ꤷIDĥƥ
	 * 
	 * @param id
	 * @return ItemBean
	 */
	public ItemBean getItemById(String id) {
		// idƱID°ͤitemΡɤXPath䤤碌̤
		String itemXML = xcon.query("/ND/address_book/item[@id = " + AddressbookUtils.getXpathConcat(XMLEncoder.xmlEncode(id)) + "]");
		// XMLDOM Document
		Document doc = AddressbookUtils.loadXMLFromString(itemXML);
		// DOM DocumentƬitemΡɤФItemBean
		ItemBean item = new ItemBean(doc.getElementsByTagName("item").item(0));
		return item;
	}
	
	/**
	 * ϿƤ륢ƥοƥID
	 * @return
	 */
	public String getNewId() {
		// IDκͤXPath
		String xpath = "max(/ND/address_book/item/@id)";
		// ̤
		String tmpItem_xml = xcon.query(xpath);
		// XMLϤ
		Document doc = AddressbookUtils.loadXMLFromString(tmpItem_xml);
		// ͤ+1
		int newIntId = AddressbookUtils.getQResultInteger(doc) + 1;
		// idη
		String newStrId = String.format("%06d", newIntId);
		return newStrId;
	}
	
	/**
	 * ѥ᡼item
	 * 
	 * @param param
	 * @return
	 */
	public ItemBean getItemByParam(ParamBean param) {
		ItemBean item = new ItemBean();
		// ѥ᡼ξ򥢥ƥꤹ
		item.setID(param.getId());
		item.setName(param.getName());
		item.setZip(param.getZip());
		item.setAddress(param.getAddress());
		item.setTel(param.getTel()); // ɲʬ
		return item;
	}
	
	
	/**
	 * Ȥ
	 * 
	 */
	public void logout() {
		xcon.logout();
	}

}
